[openwrt/openwrt] ipq40xx: sysupgrade: allow flashing Linksys factory firmware

LEDE Commits lede-commits at lists.infradead.org
Sat Dec 31 09:57:34 PST 2022


hauke pushed a commit to openwrt/openwrt.git, branch master:
https://git.openwrt.org/6fc334cbdc2b1716786768c545b761b338962b43

commit 6fc334cbdc2b1716786768c545b761b338962b43
Author: Tony Ambardar <itugrok at yahoo.com>
AuthorDate: Thu Dec 1 18:00:30 2022 -0800

    ipq40xx: sysupgrade: allow flashing Linksys factory firmware
    
    Allow forced flashing of a factory firmware image, after checking for the
    correct FIT magic header and Linksys board-specific footer. Details of the
    footer are already described in scripts/linksys-image.sh.
    
    This is convenient as it avoids using a TFTP server or OEM GUI, and allows
    restoring OEM firmware or installing a "breaking" OpenWrt update (e.g DSA
    migration and kernel repartition) directly from the command line.
    
    Devices supported at this time include EA6350v3, EA8300, MR8300 and WHW01.
    
    Reviewed-by: Robert Marko <robimarko at gmail.com>
    Tested-by:  Wyatt Martin <wawowl at gmail.com> # WHW01
    Tested-by:  Tony Ambardar <itugrok at yahoo.com> # EA6350v3
    Signed-off-by: Tony Ambardar <itugrok at yahoo.com>
---
 target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

diff --git a/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh b/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
old mode 100755
new mode 100644
index f1dc81f7c9..5d25c20ad7
--- a/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
+++ b/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
@@ -47,6 +47,14 @@ linksys_get_target_firmware() {
 	esac
 }
 
+linksys_is_factory_image() {
+	local board=$(board_name)
+	board=${board##*,}
+
+	# check matching footer signature
+	tail -c 256 $1 | grep -q -i "\.LINKSYS\.........${board}"
+}
+
 platform_do_upgrade_linksys() {
 	local magic_long="$(get_magic_long "$1")"
 
@@ -99,4 +107,14 @@ platform_do_upgrade_linksys() {
 		echo "writing \"$1\" image to \"$part_label\""
 		get_image "$1" | mtd write - "$part_label"
 	}
+
+	[ "$magic_long" = "d00dfeed" ] && {
+		if ! linksys_is_factory_image "$1"; then
+			echo "factory image doesn't match device"
+			return 1
+		fi
+
+		echo "writing \"$1\" factory image to \"$part_label\""
+		get_image "$1" | mtd -e "$part_label" write - "$part_label"
+	}
 }




More information about the lede-commits mailing list